﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Globalization;

class Program {
	static void Main(string[] args) {
		Console.WriteLine("á".CompareTo("a\u0301"));
		Console.WriteLine(String.Compare("á", "a\u0301", StringComparison.InvariantCulture));
		Console.WriteLine(String.Compare("á", "A\u0301", StringComparison.InvariantCultureIgnoreCase));
		Console.WriteLine(String.Compare("á", "a\u0301", StringComparison.Ordinal));
		Console.WriteLine(String.CompareOrdinal("á", "a\u0301"));

		Console.Write("Press ENTER to show more examples ...");
		Console.ReadLine();
		Console.WriteLine();

		Console.WriteLine();
		Console.WriteLine("á".CompareTo("a\u0301"));
		Console.WriteLine("á".Equals("a\u0301"));
		Console.WriteLine("á" == "a\u0301");

		Console.Write("Press ENTER to show more examples ...");
		Console.ReadLine();
		Console.WriteLine();

		CompareInfo ci = new CultureInfo("cs-CZ").CompareInfo;

		Console.WriteLine();
		Console.WriteLine(ci.Compare("á", "a\u0301"));
		Console.WriteLine(ci.Compare("a", "a\u0301"));
		Console.WriteLine(ci.Compare("á", "a"));

		Console.WriteLine();
		Console.WriteLine(ci.Compare("á", "a\u0301", CompareOptions.IgnoreNonSpace));
		Console.WriteLine(ci.Compare("a", "a\u0301", CompareOptions.IgnoreNonSpace));
		Console.WriteLine(ci.Compare("á", "a", CompareOptions.IgnoreNonSpace));

		Console.Write("Press ENTER to show more examples ...");
		Console.ReadLine();
		Console.WriteLine();

		/**/
		string s1 = "Řáa\u0301\u1F0B9\U0001F0B9\U0001D4D0\u0301";	// or \U0001F608

		Console.WriteLine("*** Using string: \"Řáa\\u0301\\u1F0B9\\U0001F0B9\\U0001D4D0\\u0301\"");

		foreach (char c in s1) {
			Console.Write("'{0}' ", c);
		}
		Console.WriteLine();

		var s1en = StringInfo.GetTextElementEnumerator(s1);
		while (s1en.MoveNext()) {
			Console.Write("\"{0}\" ", s1en.GetTextElement());
		}
		Console.WriteLine();

		PrintStringCharCodes(s1);

		PrintStringCharCodes(s1.Normalize(NormalizationForm.FormC));
		PrintStringCharCodes(s1.Normalize(NormalizationForm.FormD));
	}

	static void PrintStringCharCodes(string s) {
		Console.Write("String: \"{0}\"\n\tChars: ", s);
		foreach (ushort c in s) {
			Console.Write("{0:X4}({1}) ", c, (char) c);
		}
		Console.WriteLine();
	}
}

